Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions
PK_MessageAccumulator Class Reference

interface for accumulating messages to be signed or verified More...

`#include <cryptlib.h>`

Inheritance diagram for PK_MessageAccumulator:

List of all members.

## Public Member Functions

unsigned int | DigestSize () const
| should not be called on PK_MessageAccumulator
void | TruncatedFinal (byte *digest, size_t digestSize)
| should not be called on PK_MessageAccumulator
HashTransformation & | Ref ()
| return a reference to this object, useful for passing a temporary object to a function that takes a non-const reference
virtual void | Update (const byte *input, size_t length)=0
| process more input
virtual byte * | CreateUpdateSpace (size_t &size)
| request space to write input into
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | Restart ()
| discard the current state, and restart with a new message
unsigned int | TagSize () const
| same as DigestSize()
virtual unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
virtual unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| truncated version of VerifyDigest()
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Protected Member Functions

void | ThrowIfInvalidTruncatedSize (size_t size) const

## Detailed Description

interface for accumulating messages to be signed or verified

Only Update() should be called on this class. No other functions inherited from HashTransformation should be called.

Definition at line 1333 of file cryptlib.h.

## Member Function Documentation

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

compute hash for current message, then restart for a new message

Precondition:
  size of digest == DigestSize().

Definition at line 544 of file cryptlib.h.

Referenced by PKCS5_PBKDF2_HMAC< T >::DeriveKey().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

verify that digest is a valid digest for the current message, then reinitialize the object

Default implementation is to call Final() and do a bitwise comparison between its output and digest.

Definition at line 574 of file cryptlib.h.

The documentation for this class was generated from the following file:

- cryptlib.h